#include<iostream>
#include<string>
using namespace std;

int main(){
    int N;
    cin >> N;
    int N_O,N_A,N_B,N_AB;
    cin >> N_O >> N_A >> N_B >> N_AB;
    int matrica[N][4];
    string grupa;
    int n;
    for (int i=0;i<N;i++){
        cin >> grupa >> n;
        if (grupa == "O"){
            if (n>N_O) {cout << "nemoguce"; break;}
            else {
                matrica[i][o]=n;
                matrica[i][1]=0;
                matrica[i][2]=0;
                matrica[i][3]=0;
                N_O=N_O-n;
            }
        }



        if (grupa == "A"){
            if (n>N_O+N_A) {cout << "nemoguce"; brak;}
            else{
                if (n>N_A) {
                    matrica[i][0]=n-N_A;
                    matrica[i][1]=N_A;
                    matrica[i][2]=0;
                    matrica[i][3]=0;
                    N_O=N_O+N_A-n;
                    N_A=0;
                }
                else {
                    matrica[i][0]
                }
            }
        }



        if (grupa == "B"){

        }



        if (grupa == "AB"){

        }

    }

    return 0;
}